#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27,16,2);

#define pushButton 3

int  random_x;

unsigned  long  timp = 0;

int  buzzer = 5;
int stare_glont = 0;
int  i = 1;

int  glont_y;
int glont_x;

int pas_up = 15;

int pas_down = 15;

int pas_bad = 15;
//unitl here
//unit  testing
int  counter = 0;


//stare vieti
int stare = 0;

int cond1  = 0;

int  cond2 = 0;

int cond3 = 0;


int  linie_anterioara ;
int  schimbat = 0;

//For  custom_characters
byte heart[] = {
  B00000,
  B00000,
  B01010,
  B11111,
  B11111,
  B11111,
  B01110,
  B00100
};


byte empty[] = {
  B00000,
  B00000,
  B01010,
  B10101,
  B10001,
  B10001,
  B01010,
  B00100
};



byte player[] = {
  B01110,
  B01010,
  B01110,
  B00100,
  B11111,
  B00100,
  B01110,
  B01010
};

byte up[] = {
  B11111,
  B11111,
  B11111,
  B11111,
  B01110,
  B00100,
  B00000,
  B00000
};


byte down[] = {
  B00000,
  B00000,
  B00100,
  B01110,
  B11111,
  B11111,
  B11111,
  B11111
};



byte bad[] = {
  B11111,
  B11111,
  B10101,
  B11111,
  B11011,
  B11111,
  B10001,
  B11111
};


const int SW_pin = 2;
const int X_pin = 0;
const int Y_pin = 1;
int pos_x = 0;
int pos_y = 4;



int choose;

int game_phase = 0;

int scor = 0;

void i_b(){

 int buttonState = digitalRead(pushButton);

  if(buttonState == LOW ){
        if(game_phase == 0){
          game_phase = 1;
        } else if(game_phase == 2){
           asm volatile ("jmp 0");
        }
        tone(buzzer,500);
        
        stare_glont = 1;
        
  }
  
}

void setup() {

  lcd.init();
  lcd.clear();//// this gonna help at  function afisare()
  lcd.backlight();
  //cutom  time


  
  lcd.createChar(1, heart);
  lcd.createChar(0, empty);
  lcd.createChar(2, player);  
  lcd.createChar(3, up);
  lcd.createChar(4, down);
  lcd.createChar(5, bad);

  
  //until  here
  pinMode(pushButton,INPUT_PULLUP);
  attachInterrupt(digitalPinToInterrupt(pushButton), i_b,  FALLING);

  
  pinMode(SW_pin,INPUT);
  digitalWrite(SW_pin,HIGH);

}

void afisare(){  
  lcd.setCursor(pos_y,pos_x);
  lcd.write(2);   // nu sunt  sigur
}
void glont(){
  lcd.setCursor(glont_y + i,glont_x);
  lcd.print("-");
  if(glont_y + i == 15){
    stare_glont = 0;
    i = 1;
  }
}
void up_go(){
  if(pas_up > 0){


      if(pas_up != pos_y || pos_x != 0 ){
              if(pas_up == pos_y - 1 && pos_x == 0 && schimbat == 0 ){ 
                    stare ++;
                    pas_up = 15;
                    cond1 = 0 ;  
                    tone(buzzer,800); 
              }else{
               lcd.setCursor(pas_up,0);
               lcd.write(3);
               pas_up -- ;  
              }
              
      } else {
        stare ++;
        pas_up = 15;
        cond1 = 0;
        tone(buzzer,800);
      }

  }else{
        pas_up = 15;
        cond1 = 0;
  }
//  else {
//    asm volatile ("jmp 0");
//  }
}

void down_go(){
  if(pas_down > 0){
      if(pas_down != pos_y || pos_x != 1 ){ 

              if(pas_down == pos_y - 1 && pos_x == 1 && schimbat == 0 ){ 
                    stare ++;
                    pas_down = 15;
                    cond2 = 0 ;  
                    tone(buzzer,800); 
              } else{
                 lcd.setCursor(pas_down,1);
                 lcd.write(4);
                 pas_down -- ;
              }
              
      } else {
        stare ++;
        pas_down = 15;
        cond2 = 0;
        tone(buzzer,800); 
      }

  }else{
        pas_down = 15;
        cond2 = 0;
  }

}

void bad_go(){
  if(pas_bad > 0 ){ 
      if(pas_bad <= glont_y + i &&  glont_x == random_x && stare_glont == 1){ 
        pas_bad = 15;
        cond3 = 0;
        scor ++;
        tone(buzzer,800);     
      }else if(pas_bad != pos_y || pos_x != random_x ){  //aici  posibil
              if(pas_bad == pos_y - 1 && pos_x == random_x && schimbat == 0){
                    stare ++;
                    pas_bad = 15;
                    cond3 = 0 ;  
                    tone(buzzer,800); 
              }else{
                lcd.setCursor(pas_bad,random_x);//poate fi si 0
                lcd.write(5);
                pas_bad -- ;

                
              }
      } else {
        stare ++;
        pas_bad = 15;
        cond3 = 0 ;
        tone(buzzer,800); 
      }      
  } else{
        pas_bad = 15;
        cond3 = 0 ;
  }
}

void loop() {

  if(game_phase == 0){
        lcd.setCursor(3,0);
        lcd.print("PM-STATION");

        lcd.setCursor(0,1);
        lcd.print("-press to start-");

        
    
    } else if(game_phase == 1){
         linie_anterioara = pos_x;
     if(analogRead(X_pin) < 400){
      if(pos_y != 15){
        pos_y ++;
      }
      
    } else if(analogRead(X_pin) > 900){
      if(pos_y >1 ){
        pos_y --;
      }
     
    }
  
  
    if(analogRead(Y_pin) < 400){
      if(pos_x!= 1){
        pos_x ++;     
      }
   
    } else if(analogRead(Y_pin) > 900){
      if(pos_x !=0){
        pos_x --;     
      }
   
    }
  
    if(pos_x != linie_anterioara){
      schimbat = 1;
    } else {
      schimbat = 0;
    }
    
    //alegere  inamic/obstacol
  
    
     if(cond1 == 0 && cond2 == 0 && cond3 == 0){
        choose = random(1,4);
        if(choose ==  1){
            cond1 = 1;
        } else if(choose ==  2){
          cond2=1;
        }else if(choose ==  3){
          cond3=1;
          random_x = random(0,2);
        }
     }
    
    //zona pentru  vieti:
  
  
  
    if(stare == 0){
        lcd.setCursor(0,0);
        lcd.write(1);
    }else{
        lcd.setCursor(0,0);
        lcd.write(0);
    }
  
  
    if(stare <= 1){
        lcd.setCursor(0,1);
        lcd.write(1);
    }else {
      lcd.setCursor(0,1);
      lcd.write(0);
      delay(100);
      game_phase = 2; // jus for now
    }
  
   
  
  //Zona  glont:
  
    
  
    if(stare_glont == 1){
      if(i == 1){
        glont_y = pos_y;
        glont_x = pos_x;
        counter ++;
      }
      glont();
      i++;
    }else{
      i = 1;
    }
    
  
  
  //zona  desen
    
    
    if(choose == 1 && cond1 == 1){
      up_go();
    } else if(choose == 2 && cond2 == 1){
      down_go();
    }else if(choose == 3 && cond3 == 1){
      bad_go();
    }
    afisare();
  
  
    delay(250);
   
    noTone(buzzer);
    lcd.clear();
    }
    else if(game_phase == 2){
        lcd.setCursor(3,0);
        lcd.print("DAMN SON!!!");

        lcd.setCursor(3,1);
        lcd.print("SCOR:");

        lcd.setCursor(9,1);
        lcd.print(scor);

        
    }
    
}
